<?php
class Clerk {
	var $buttons, $headings, $labels, $hints, $customer, $task, $writer;
	function Clerk() {
		global $pth, $sl, $sn, $cf;
		$zShopSettings = array();
		include_once $pth['folder']['plugins'].'/wellrad/zShopLanguages/'.$sl.'.php';
		include $pth['folder']['plugins']."wellrad/config/shopsettings.php";
		include_once $pth['folder']['plugins']."wellrad/collaborators/customer.inc";
		include_once $pth['folder']['plugins']."wellrad/collaborators/product.inc";
		include_once $pth['folder']['plugins']."wellrad/collaborators/catalogue.inc";
		include_once $pth['folder']['plugins']."wellrad/collaborators/shopdecorator.inc";
		$this -> separator = $cf['uri']['seperator'];
		$this -> language = $sl;
		$this -> buttons = $lang['buttons'];
		$this -> labels = $lang['labels'];
		$this -> headings = $lang['headings'];
		$this -> hints = $lang['hints'];
		$this -> mail = $lang['mail'];
		$this -> settings = $zShopSettings;
		$this -> zUrl = $sn."?".$zShopSettings[$sl]['url'];
		$this -> catalogue = new Catalogue($this -> separator);
		$this -> decorator = new ShopDecorator();
		$this -> writer = new HtmlWriter($sl);
	}

	function get_price($product){
		if($this->settings['show_netto']=='true'){
			return $product->get_netto($this->settings['vat_full'],$this->settings['vat_reduced']);
		}
		return $product->price;
	}

	function do_your_task() {
		$task = 'show_the_catalogue';
		if($_POST['task']) {
			$task = $_POST['task'];
		}
		if($_POST['order_step']) {
			$task = $_POST['order_step'];
			if(count($_SESSION['customer'] -> cart) == 0) {
				$task = 'show_the_catalogue';
			}
		}
		if($_POST['custom']=='finish_the_order') { // von paypal
			$task = 'finish_the_order';
		}
		$this -> task = $task;
		if(method_exists($this, stripslashes($this -> task))) {
			$task = stripslashes($this -> task);
			$return =  $this-> $task();
		} else {
			$return = "<p style=\"color: red;\">Clerk versteht nicht: $task</p>";
			$return .= $this -> show_the_catalogue();
		}
		if(($task == 'add_to_cart') && (!$_POST['order_step'])) {
			$return = $this -> show_the_catalogue();
		}
		return $return;
	}

	function show_the_catalogue() {
		$products = $this -> catalogue -> products;
		$categories = $this -> catalogue -> categories[$this -> language];
		$standard_category = $this -> catalogue -> category_for_the_left_overs[$this -> language];
		$default_category = $this -> catalogue -> default_category[$this -> language];
		if(!isset($standard_category)) {
			$standard_category = $this -> settings[$this -> language]['category_for_left_over_products'];
		}

		if(isset($default_category)) {
			$filter = $default_category;
		}
		if(!empty($_GET['chosen_category'])) {

			if(!empty($_POST['chosen_category'])) {
				unset($_GET['chosen_category']);
			} else {$filter = urldecode($_GET['chosen_category']);}
		}

		if(!empty($_POST['chosen_category'])) {
			$filter = $_POST['chosen_category'];
		}


		$are_there_left_overs = $this -> are_there_products_without_category();
		if(
		($this->settings['use_categories']=='true')
	 && (!empty($filter))
	 && ($filter <> $this -> labels['all_categories'])
		) {
			$filtered = array();
			if($filter ==  'left_overs'){
				foreach($products as $product) {
					if(count($product -> categories[$this -> language])< 1) {
						$filtered[] = $product;
					}
				}
			}
			else {
				foreach($products as $product) {
					if(in_array($filter,$product->categories[$this -> language])){
						$filtered[] = $product;

					}
				}
			}
			$categories = $this -> catalogue -> categories[$this -> language];
			$products = $filtered;
		}

		$return .= $this -> decorator -> create_header_for_products_table($categories, $standard_category, $are_there_left_overs, $filter);
		$return .= $this -> decorator -> create_the_rows_for_products_table($products);
		$return .= $this -> decorator -> create_footer_for_products_table();
		return $return;
	}

	function are_there_products_without_category() {
		foreach($this -> catalogue -> products as $product) {
			if(count($product -> categories[$this -> language])< 1) {
				return true;
			}
		}
		return false;
	}


	/**
	 *
	 *
	 * @return string
	 */
	function offer_to_order(){

		$return = $this -> present_the_cart();
		$return .= $this -> decorator -> start_the_start_order_form();
		$charge = $this -> do_i_have_to_charge_for_shipping();
		$return .= $this -> decorator -> ask_for_shipping_area($charge);
		$return .= $this -> decorator -> finish_the_start_order_form();
		return $return;
	}

	/**
	 * ich fordere vom ShopDecorator den HTML-Code für das Eingabeformular für die Kundendaten a
	 *
	 * @return String
	 */
	function ask_for_order_data() {
		$shipping = split(',',$_POST['shipping']);
		$_SESSION['customer'] -> destination_area = trim($shipping[0]);
		$_SESSION['customer'] -> forwarding_expenses = trim($shipping[1]);
		$_SESSION['customer'] -> vat_area = trim($shipping[2]);
		$return = $this -> decorator -> create_the_order_data_form();
		return $return;
	}
	function check_the_order_data() {
		$fee = $this -> settings['payment_fee'][$_POST['payment_mode']];
		if(isset($fee)) {
			$_SESSION['customer'] -> fee = $fee;
		}
		$customer_infos = array('first_name', 'last_name', 'zip_code', 'city', 'payment_mode', 'street', 'cos_confirmed', 'annotation', 'e_mail');
		foreach($customer_infos as $info) {
			if(strlen(trim(($_POST[$info]))) > 0) {
				$_SESSION['customer'] -> $info = $_POST[$info];
			}
		}
		if($this -> do_i_have_to_bother_my_customer_for_more_information()){
			$missing_infos = $this -> do_i_have_to_bother_my_customer_for_more_information();
			$return = $this -> decorator -> create_form_for_missing_customer_data($missing_infos);
		}
		else {$return = $this -> ask_for_final_confirmation();}
		return $return;
	}

	function ask_for_final_confirmation() {
		
		$return = $this->hints['ask_for_final_confirmation'];
		$return .= "\n<fieldset><legend>".$this->labels['summary']."</legend>";
		$return .= $this -> decorator -> create_customers_data_table();
		$cart_items = $this ->get_products_from_cart();
		
		$cart_netto = $this -> get_cart_netto();
		$shipping = (float) $_SESSION['customer'] -> forwarding_expenses;
		$fee = (float) $_SESSION['customer'] -> fee;
		
		$vat = $this-> get_cart_taxes();
		$fees = $shipping + $fee;
		
		
		$cart_brutto = $this -> get_cart_brutto();
		$splitted_brutto = $this->get_splitted_cart_brutto();
		
		
		$faktor = ($splitted_brutto['full']/$cart_brutto);
		$fee_vat_full = ($fees *  $faktor) - ($this->to_netto($fees * $faktor, $this->settings['vat_full']));
		
		$faktor = ($splitted_brutto['reduced']/$cart_brutto);
		$fee_vat_reduced = ($fees *  $faktor) - ($this->to_netto($fees * $faktor, $this->settings['vat_reduced']));
			
		$fees = $fees - $this->to_netto($fees,$this->settings['vat_full']);
		$vat['full'] = $vat['full'] + $fee_vat_full;
		$vat['reduced'] = $vat['reduced'] + $fee_vat_reduced;
		if($this->settings['minimum_order'] > ($cart_brutto + $shipping + $fee)) {
			return $this->hints['order_minimum_warn_1']. " ". $this->writer->format_the_money($this->settings['minimum_order']). "&nbsp;". $this->settings['default_currency'].$this->hints['order_minimum_warn_2'];
		}
//		$shipping_vat = $shipping - $this->to_netto($shipping, $this->settings['vat_full']);
		$fee_vat = $fee_vat_full + $fee_vat_reduced;		
		if($this->settings['show_netto'] == 'true'){
			$shipping = $this->to_netto($shipping, $this->settings['vat_full']);
			$fee = $this->to_netto($fee, $this->settings['vat_full']);
		}


		$_SESSION['customer']->vat['full'] = $vat['full'];
		$_SESSION['customer']->vat['reduced'] = $vat['reduced'];
		$_SESSION['customer']->cart_sum = $cart_brutto + $shipping + $fee;
		
		$return .= $this -> decorator -> create_customers_order_table($cart_items, $shipping, $fee, $shipping_vat, $fee_vat, $cart_netto, $cart_brutto, $vat);
		$return .= "\n</fieldset>";
		return $return;
	}

	function to_netto($sum, $tax_rate){
		$netto = ($sum/(100+$tax_rate))*100;
		return $netto;
	}

	function get_products_from_cart(){
		foreach($_SESSION['customer'] -> cart as $key => $amount) {
			$cart_items[] = array('product' => $this -> catalogue -> products[$key],
							  'amount' => $amount, 
							  'price' => $this->get_price($this -> catalogue -> products[$key]));
		}
		return $cart_items;
	}

	function get_cart_netto(){
		$netto = 0;
		foreach($_SESSION['customer'] -> cart as $key => $amount) {
			$temp = $this -> catalogue -> products[$key]->get_netto($this->settings['vat_full'], $this->settings['vat_reduced']);
			$netto += $temp * $amount;
		}
		return $netto;
	}
	
	function get_cart_brutto(){
		$brutto = 0;
		foreach($_SESSION['customer'] -> cart as $key => $amount) {
			$brutto += $this -> catalogue -> products[$key]->price * $amount;
		}
		return $brutto;
	}
	function get_cart_taxes(){
		$full = 0;
		$reduced = 0;
		foreach($_SESSION['customer'] -> cart as $key => $amount) {
			$temp = $this -> catalogue -> products[$key]->get_included_tax($this->settings['vat_full'], $this->settings['vat_reduced']);
			$tax = $temp * $amount;
			if($this -> catalogue -> products[$key]->vat == 'full'){
				$full += $tax;
			}
		if($this -> catalogue -> products[$key]->vat == 'reduced'){
				$reduced += $tax;
			}
		}
		$vat['full'] = $full;
		$vat['reduced'] = $reduced;
		return $vat;
	}
	
	function get_splitted_cart_brutto(){
		$full = 0;
		$reduced = 0;
		foreach($_SESSION['customer'] -> cart as $key => $amount) {
			if($this -> catalogue -> products[$key]->vat == 'full'){
				$full += $this -> catalogue -> products[$key]->price * $amount;
			}
		if($this -> catalogue -> products[$key]->vat == 'reduced'){
				$reduced += $this -> catalogue -> products[$key]->price * $amount;
			}
		}
		$splitted_brutto['full'] = $full;
		$splitted_brutto['reduced'] = $reduced;
		return $splitted_brutto;
	}

	function finish_the_order() {
		$this -> write_the_bill();
		$return = $this -> say_thanks();
		return $return;
	}
function write_the_bill() {
		global $pth, $sl;

		$currency = $this -> settings['default_currency'];
		if(($currency == '&euro;') || $currency == '&#8364;') {$currency = 'EUR';}
		if(($currency == '&pound;') || $currency == '&#163;') {$currency = 'GBP';}
		if(($currency == '&yen;') || $currency == '&#165;') {$currency = 'YEN';}

		$bill_template = $pth['folder']['plugins']."wellrad/bills/template.rtf";
		$this -> fh = fopen($bill_template, "r") or die("can't open ($bill_template) ");
		$temp = fread($this->fh, filesize($bill_template));
		fclose($this->fh);
		$replacements = $this -> collect_the_bills_data($currency);
		foreach($replacements as $place_holder => $value) {
			$temp = str_replace($place_holder, $value, $temp);

		}
		$attach = $temp;
		if((isset($customer -> forwarding_expenses))
		&& (strlen(trim($customer -> forwarding_expenses)) > 0)) {
			$forwarding_expenses = $customer -> forwarding_expenses;
		}

		$customer = $_SESSION['customer'];
		$vorname = $customer-> first_name;
		$nachname = $customer -> last_name;
		$strasse = $customer -> street;
		$plz = $customer -> zip_code;
		$ort = $customer -> city;
		$email = $customer -> e_mail;
		$cos = $customer -> cos_confirmed;
		$annotation = $customer -> annotation;

		$mail_text = $this->mail['your_adress']."\n$vorname $nachname\n$strasse\n$plz $ort\n\n$email\n\n";
		$mail_text .= $this -> mail['your_order']."\n";
		$mail_text .= $this ->write_products_for_email();
		$mail_text .= "\n".$this -> mail['sub_total']."\t\t\t ". $replacements['%SUMME%'] ;
		$mail_text .= "\n".$this->mail['shipping']."\t\t\t ". $replacements['%SHIPPING%'];
		if($customer -> fee) {
			
			$mail_text .= "\n" . $replacements['%FEE_LABEL%']. ":\t\t". $replacements['%FEE%'];
		}

		$mail_text .= "\n".$this->mail['total']."\t\t\t ". $replacements['%ENDSUMME%'] ."&nbsp;". $currency."\n\n";
		$mail_text .= $this->mail['cos']."&nbsp;".$cos."\n\n".$this->mail['annotation']."\n".$annotation."\n\n\n";
		$vat_hint = $this->write_vat_info($currency);
		$mail_text .= $vat_hint;

		//ein kleiner, unvollständiger Plausiblitätscheck für die eMail-Adresse
		list($user,$domain) = split("@", $email);
		$domain =split("\.", $domain);
		if((count($user >= 1)) && (count($domain > 1))
		&& (strlen($domain[0])>2)&& (strlen($domain[(count($domain)-1)])>1) && (strlen($domain[(count($domain)-1)]) < 5)){

			$attach = base64_encode($attach);
			$attach = chunk_split($attach,70,"\n");
			$message = $this->mail['salutation'] . " " . $vorname . " " . $nachname .",\n\n";
			$message .= ($this->mail['thank_you']);
			$message .= $mail_text ."\n\n";
			$message .= $this->mail['greetings'] .$this->settings['company_name'];

			$html_table = get_html_translation_table(HTML_ENTITIES);
			$change_back_table = array_flip($html_table);
			$message = strtr($message, $change_back_table);
			$mail_text = strtr($mail_text, $change_back_table);


			$from = $this->settings['order_email'];
			$subject = $this->mail['email_subject'] . $this->settings['company_name'];
			$to = $email;

			$header = "MIME-Version: 1.0\n";
			$header .= "From: ". $this->settings['company_name']. " <$from>\n";
			$header .= "Reply-To: " . $this->settings['company_name']. " <$from>\n";
			$header .= "Return-Path: " . $this->settings['company_name']. " <$from>\n";
			$header .= "Error-To: " . $this->settings['company_name']. " <$from>\n";
			$header .= 'Date: ' . date('r') . "\n";

			mail($to, $subject, $message,$header );
			$boundary = md5(uniqid(time()));
			$header .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\n";
			$header .= "This is a multi-part message in MIME format -- Dies ist eine mehrteilige Nachricht im MIME-Format.\n\n";
			$header .= "--".$boundary."\n";
			$header .= "Content-Type: text/plain\n";
			$header .= "Content-Transfer-Encoding: 8bit\n";
			$header .= $mail_text ."\n\n";
			$header .= "--".$boundary."\n";
			$header .= "Content-Type: application/rtf; name=bill.rtf\n";
			$header .= "Content-Transfer-Encoding: base64\n";
			$header .= "Content-Disposition: attachment; filename=bill.rtf\n\n";
			$header .= $attach."\n\n";
			$header .= "--".$boundary."--";
			$subject = $this->mail['notify'];
			//mail($to, $subject, null, $header);

			mail($from, $subject, null, $header );
		}
	}

	function collect_the_bills_data($currency) {
		global $sl;
		if($sl == 'de'){
			setlocale(LC_TIME, "de_DE", "ge", "de");
		}
		$datum =strftime('%A, %d. %B %Y');
		$html_table = get_html_translation_table(HTML_ENTITIES);
		$change_back_table = array_flip($html_table);
		$customer = $_SESSION['customer'];
		$fee_label = ' - ';
		$fee = '0,00';
		$shipping = 0;
		$shipping = $customer -> forwarding_expenses;
		if($customer -> fee) {
			$fee = $customer -> fee;
			if($fee >= 0) {
				$fee_label = $this -> labels['fee'];

			}
			if($fee < 0) {
				$fee_label = $this -> labels['reduction'];
			}
			$fee_label .= " " . $this -> labels[$customer -> payment_mode];
			$fee_label = strtr($fee_label, $change_back_table);
		}
	if($_SESSION['customer'] -> vat_area == 'off' && $this->settings['dont_deal_with_taxes'] !== 'true'){
		$cart_brutto = $this->get_cart_brutto();
		$splitted_brutto = $this->get_splitted_cart_brutto();
			
		$faktor = ($splitted_brutto['full']/$cart_brutto);
		$shipping_full = ($shipping * $faktor) - ($this->to_netto($shipping * $faktor, $this->settings['vat_full']));
		$fee_vat_full = ($fee *  $faktor) - ($this->to_netto($fee * $faktor, $this->settings['vat_full']));
		
		$faktor = ($splitted_brutto['reduced']/$cart_brutto);
		$fee_vat_reduced = ($fee *  $faktor) - ($this->to_netto($fee * $faktor, $this->settings['vat_reduced']));
		$shipping_reduced = ($shipping *  $faktor) - ($this->to_netto($shipping * $faktor, $this->settings['vat_reduced']));
		
		$fee = $fee - $fee_vat_full - $fee_vat_reduced;
		$shipping = $shipping - $shipping_full - $shipping_reduced;
		
			$subtotal = $this->get_cart_netto();
		}else {$subtotal = $this->get_cart_brutto();}

	$vat_hint = nl2br($this -> write_vat_info($currency));
	$vat_hint = str_replace('<br />', '\line', $vat_hint);
	$vat_hint = str_replace('<br>', '\line', $vat_hint);
	$vat_hint = str_replace('&sect;', '\\\'a7', $vat_hint);
	$vat_hint = str_replace('&#167;', '\\\'a7', $vat_hint);
	
	$data_array = array(
	'%Datum%' => $datum,
	'%Vorname%' => $customer -> first_name,
	'%Nachname%' => $customer -> last_name,
	'%Strasse%' => $customer -> street,
	'%PLZ%' => $customer -> zip_code,
	'%Ort%' => $customer -> city,

	'%COMPANY_NAME%' => $this->settings['company_name'],
	'%COMPANY_STREET%' => $this->settings['street'],
	'%COMPANY_ZIP%' => $this->settings['zip_code'],
	'%COMPANY_CITY%' => $this->settings['city'],

	'%rows%' => $this -> write_product_rows_for_bill(),
	'%SUMME%' => $this->writer->format_the_money($subtotal),
	'%SHIPPING%' => $this->writer->format_the_money($shipping),
	'%FEE_LABEL%' => $fee_label,
	'%FEE%' => $this->writer->format_the_money($fee),
	'%ENDSUMME%' => $this->writer->format_the_money($subtotal + $shipping + $fee),
	'%MWST_HINWEIS%' => $vat_hint,
		);
		return $data_array;
	}




	function say_thanks() {
		$return = $this ->hints['thanks_and_offer_printing'];

		session_unset($customer);
		return($return);
	}

	function write_product_rows_for_bill() {
	$short = '';
	$currency = $this->settings['default_currency'];
	if($currency == '&euro;'){$currency = "\'80";}
	if($currency == '&pound;'){$currency = "{\'a3}";}
	if($currency == '&yen;'){$currency = "\'a5";}	
	 foreach($_SESSION['customer'] -> cart as $index => $amount) {
	 	$item = $this -> catalogue ->products[$index];
	 	if($this->settings['dont_deal_with_taxes']!=='true'){
	 		if($item->vat == 'reduced'){
	 			$rate = $this->settings['vat_reduced'];
	 			
	 			}else {$rate = $this->settings['vat_full'];
	 					$short = '1';
	 		}
	 		$short = '('.$rate.' %)';
	 	}
	 	$name = $item ->names[$this -> language];
	 	if($_SESSION['customer'] -> vat_area == 'off' && $this->settings['dont_deal_with_taxes'] !== 'true'){
	 		$price = $item->get_netto($this->settings['vat_full'], $this->settings['vat_reduced']);
	 	}else {	$price = $item -> price;}
	 	//$summe = $summe + $item -> price * $amount;
	 	$rows.= '\trowd\trql\trleft-20\trpaddft3\trpaddt0\trpaddfl3\trpaddl10\trpaddfb3\trpaddb0\trpaddfr3\trpaddr10\clbrdrl\brdrs\brdrw1\brdrcf1\clbrdrb\brdrs\brdrw1\brdrcf1\clvertalb\cellx724\clbrdrl\brdrs\brdrw1\brdrcf1\clbrdrb\brdrs\brdrw1\brdrcf1\cellx5036\clbrdrl\brdrs\brdrw1\brdrcf1\clbrdrb\brdrs\brdrw1\brdrcf1\clvertalb\cellx6481\clbrdrl\brdrs\brdrw1\brdrcf1\clbrdrb\brdrs\brdrw1\brdrcf1\clbrdrr\brdrs\brdrw1\brdrcf1\clvertalb\cellx8640
\pard\intbl\pard\plain \intbl\ltrpar\s1\cf0\qr{\*\hyphen2\hyphlead2\hyphtrail2\hyphmax0}\rtlch\af1\afs24\lang255\ltrch\dbch\af1\langfe255\hich\f1\fs24\lang1031\loch\f1\fs24\lang1031 {\rtlch \ltrch\loch\f1\fs24\lang1031\i0\b0 '.$amount.'}
\cell\pard\plain \intbl\ltrpar\s1\cf0{\*\hyphen2\hyphlead2\hyphtrail2\hyphmax0}\rtlch\af1\afs24\lang255\ltrch\dbch\af1\langfe255\hich\f1\fs24\lang1031\loch\f1\fs24\lang1031 {\rtlch \ltrch\loch\f1\fs24\lang1031\i0\b0 '.$name."\t".$short.'}
\cell\pard\plain \intbl\ltrpar\s1\cf0\qr{\*\hyphen2\hyphlead2\hyphtrail2\hyphmax0}\rtlch\af1\afs24\lang255\ltrch\dbch\af1\langfe255\hich\f1\fs24\lang1031\loch\f1\fs24\lang1031 {\rtlch \ltrch\loch\f1\fs24\lang1031\i0\b0 '.$this->writer->format_the_money($price).' }
\cell\pard\plain \intbl\ltrpar\s1\cf0\qr{\*\hyphen2\hyphlead2\hyphtrail2\hyphmax0}\rtlch\af1\afs24\lang255\ltrch\dbch\af1\langfe255\hich\f1\fs24\lang1031\loch\f1\fs24\lang1031 {\rtlch \ltrch\loch\f1\fs24\lang1031\i0\b0 '.$this->writer->format_the_money($price * $amount).' '.$currency.'}\cell\row';

	 }
	 return $rows;
	}

	function write_products_for_email() {
	 foreach($_SESSION['customer'] -> cart as $index => $amount) {
	 	$item = $this -> catalogue ->products[$index];
	 	$name = $item ->names[$this -> language];
	 if($_SESSION['customer'] -> vat_area == 'off' && $this->settings['dont_deal_with_taxes'] !== 'true'){
	 		$price = $item->get_netto($this->settings['vat_full'], $this->settings['vat_reduced']);
	 	}else {	$price = $item -> price;}
	 	$rows.= $amount . " * " . $name . "\t\t(&agrave; " . $this->writer->format_the_money($price) .")\t" ."= " . $this->writer->format_the_money($price * $amount). "\n";
	 }
	 return $rows;
	}



	function write_vat_info($currency) {
		$full = $_SESSION['customer']->vat['full'];
		$reduced = $_SESSION['customer']->vat['reduced'];
		$vat_hint = $this -> hints['no_vat_bill'];
		if($this -> settings['dont_deal_with_taxes'] == 'false') {
			$vat_hint =  $this->labels['included_vat'] . " ";
			if($full > 0) {
				$netto = $this->writer->format_the_money($full/$this->settings['vat_full']*100) . " " . $currency;
				$full = $this->settings['vat_full'] . $this->hints['on_netto']. $netto .": ". $this->writer->format_the_money($full) . " " . $currency;
			}
			else {$full='';}
			if($reduced > 0) {
				$netto =  $this->writer->format_the_money($reduced/$this->settings['vat_reduced']*100) . " " . $currency;
				$reduced = $this->settings['vat_reduced'] . $this->hints['on_netto']. $netto .": ". $this->writer->format_the_money($reduced). " " . $currency;
			}
			else {$reduced='';}
			if(($full > 0) && ($reduced > 0)) {
				$separator = "\r\n";
			}
			$vat_hint .= $full.$separator.$reduced;
			if($_SESSION['customer'] -> vat_area == 'off') {
				$vat_hint = $this->hints['no_vat_export_bill'];
			}
		}
		
		return $vat_hint;
	}

	function do_i_have_to_bother_my_customer_for_more_information(){
		$necesary_contact_infos = array('first_name', 'last_name', 'zip_code', 'city', 'street', 'e_mail');
		$missing_infos = array();
		foreach($necesary_contact_infos as $info) {
			if((!isset($_SESSION['customer'] -> $info))) {
				$missing_infos['contact'][] = $info;
			}
		}
		if((!isset($_SESSION['customer'] -> cos_confirmed))) {
			$missing_infos['cos_confirmed'] = 'cos_confirmed';
		}
		if((!isset($_SESSION['customer'] -> payment_mode))) {
			$missing_infos['payment_mode'] = 'payment_mode';
		}
		if(count($missing_infos) > 0) {
			return $missing_infos;
		}
		return false;
	}

	function do_i_have_to_charge_for_shipping() {
		if($this -> settings['charge_for_shipping'] <> 'true') {
			return false;
		}
		$items = 0;
		foreach($_SESSION['customer'] -> cart as $index => $amount) {
			$item = $this -> catalogue -> products[$index];
			$items = $items + $amount;
			$summe = $summe + $this -> get_price($item) * $amount;
		}
		if(($items >= $this -> settings['forwarding_expenses_up_to']['items'])
		|| $summe >= $this -> settings['forwarding_expenses_up_to']['sum']){
			return false;
		}
		return true;
	}

	function add_to_cart() {
		global $o;
		if(count($_COOKIE) == 0) {
			//$o.= "<p style=\"color: red\">Hinweis: Um unseren Shop zu benutzen, erlauben Sie bitte Ihrem Browser das Akzeptieren von Cookies.</p>";
		} else {
			session_start();
	 	if(!$_SESSION['customer']) {
		 	$customer = new Customer();
		 	$_SESSION['customer'] = $customer;
	 	}
	 	$_SESSION['customer'] -> add_item_to_cart($_POST['cart_item'], $_POST['amount']);
		}
	}

	function present_the_cart_preview() {
		if($this -> settings['published'] == 'false') {
			unset($_SESSION['customer']);
			return "<p class=\"warn\">".$this->hints['sorry_we_are_closed']."</p>";
		}
		if($_POST['order_step']) {return;}
		$rows = '';
		$summe = 0;
		$i = 0;
		$counter = 0;
		foreach($_SESSION['customer'] -> cart as $index => $amount) {
			$i++;
			$css_class = 'odd';
			if(is_integer($i/2)) {$css_class="even";}
	 	$item = $this -> catalogue ->products[$index];
	 	if(is_a($item, 'product')) {
	 		$counter++;
	 		$price = $this->get_price($item);
		 	$rows .= $this->decorator -> create_table_row_for_cart_preview($item, $price, $amount, $css_class);
		 	$summe = $summe + $price * $amount;
	 	}
		}
		if($counter == 0) {
			return;
		}
		$return = $this -> decorator -> create_the_cart_preview_heading($summe, $this -> headings['shopping_cart'], $this -> buttons['go_to_cart']);
		$return .= "\n<table cellspacing=\"0px\" cellpadding=\"0px\">";
		$return .= $rows;
		$return .= "\n</table>\n</div>";
		return $return;

	}

	function present_the_cart() {
		$rows = '';
		$summe = 0;
		$i = 0;
		$counter = 0;
		foreach($_SESSION['customer'] -> cart as $index => $amount) {
			$i++;
			$css_class = 'odd';
			if(is_integer($i/2)) {$css_class="even";}
			$item = $this -> catalogue ->products[$index];
			if(is_a($item, 'product')) {
				$counter++;
				$price = $this->get_price($item);
				$rows .= $this->decorator->create_table_row_for_cart($item, $price, $amount, $css_class);
				$summe = $summe + $price * $amount;
			}
		}
		if($counter == 0) {
			return;
		}
		$return = $this -> decorator -> create_the_cart_heading($summe, $this -> headings['shopping_cart'], $this -> buttons['go_to_cart']);
		$return .= $rows;
		$return .= "\n</table>\n\n";
		return $return;
	}


	function add_an_add_to_cart_button($product,$lang,$current_page){
		$price = $this->writer->format_the_money($this->get_price($product));
		$decimals = substr($price, -2);
		$price = substr_replace($price, '<sup>'.$decimals.'</sup>',-2);
		$orderButton = "\n<div id=\"cartButton\">";
		$orderButton .= "\n\t\t<b>".$product ->names[$lang]."</b> ";
		
		$orderButton .= "\n\t\t<div style=\"white-space:nowrap; text-align: right;margin-top: 8px;\"><b>".$this -> labels['price']."&nbsp;". $price ."&nbsp;". $this -> settings['default_currency']."</b>";
		if(trim($this->hints['price_info_vat']) !== '' || trim($this->hints['price_info_shipping']) !== ''){
			$orderButton .= $this->decorator->add_price_infos($product);
		}	
		$orderButton .= "</div>";
		$orderButton .= "\n\t<div style=\"text-align: right;margin-top: 8px;\">";
		
		$orderButton .= "\n\t\t<form action=\"\" method=\"post\" style=\"display: inline;\">";
		$orderButton .= "\n\t\t<input type=\"text\" size=\"2\" style=\"display: inline; width: 1.5em;\" name=\"amount\" value=\"1\" />";
		$orderButton .= "\n\t\t<input type=\"hidden\" name=\"cart_item\" value=\"".$product -> counter ."\" />";
		$orderButton .= "\n\t\t<input type=\"hidden\" name=\"".session_name()."\" value=\"".session_id()."\" />";
		$orderButton .= "\n\t\t&nbsp;x&nbsp;<input type=\"submit\" class=\"shopButton\" style=\"margin-bottom: 0px;\" value=\"".$this->buttons['add_to_cart']."\" />";
		$orderButton .= "\n\t</form>";
		$orderButton .= "\n\t</div>\n</div>\n";
		return preg_replace('/(<\/h[1-8]>)/i', "$1 $orderButton", $current_page,1);
	}

	function get_the_product_linked_to_current_page($lang){
		$page_name = "?".$_SERVER['QUERY_STRING'];
		$productPages = array();
		foreach($this -> catalogue -> products as $product) {
			foreach($product -> productPages[$lang] as $page) {
				$productPages[] = $page;
				if($page == $page_name){
					return $product;
				}
			}
		}
		return false;
	}

}
?>