<?php

/**
 * Ich bin verantwortlich für die Shop-Verwaltung:  
 * - die Oberfläche stellt mir der ShopDecorator zur Verfügung;
 * - die Daten beziehe ich aus
 *
 */
class Manager {
var $help_path, $buttons, $headings, $labels, $hints, $settings, $zUrl, $settingsFile, $decorator;
function Manager() {
	global $sl, $pth, $sn, $cf;
	$zShopSettings = array();
 	include $pth['folder']['plugins']."wellrad/config/shopsettings.php";
 	include_once $pth['folder']['plugins'].'/wellrad/zShopLanguages/'.$sl.'.php';
 	include_once $pth['folder']['plugins']."wellrad/collaborators/product.inc";
 	include_once $pth['folder']['plugins']."wellrad/collaborators/catalogue.inc";
 	include_once $pth['folder']['plugins']."wellrad/collaborators/contentmanager.inc";
 	include_once $pth['folder']['plugins']."wellrad/collaborators/officedecorator.inc";
 	
 	$this -> separator =$cf['uri']['seperator'];
 	$this -> settingsFile = $pth['folder']['plugins']."wellrad/config/shopsettings.php";
 	$this -> language = $sl;
 	$this -> help_path = $pth['folder']['plugins']."wellrad/help/";
 	$this -> buttons = $lang['buttons'];
 	$this -> labels = $lang['labels'];
 	$this -> headings = $lang['headings'];
 	$this -> hints = $lang['hints'];
 	$this -> settings = $zShopSettings;
 	$this -> zUrl = $sn."?".$zShopSettings[$sl]['url'];
	$this -> decorator = new OfficeDecorator();
 	$this -> catalogue = new Catalogue($this -> separator);
 	$this -> contentmanager = new ContentManager($pth['file']['content']);
 	// add this new setting - just for compatibility with versions <= 1.0.1
	if(!$this->settings['minimum_order']) {	
			$this->settings['minimum_order']= 0.00;
		}
	if(!$this->settings['show_netto']) {	
			$this->settings['show_netto']= 'false';
		}

 }
 
 function do_your_task() {
 	$task = "keine Aufgabe";
 	if($_POST['task']) {
	$task = $_POST['task'];
	$this -> task = $task;
	$return = $this -> decorator -> make_administrators_menu();
	if (method_exists($this, stripslashes($task))) {
			$task = stripslashes($this -> task);
			$return .=  $this -> $task();
		}
		else {
			$backtrace = debug_backtrace();
			$return .=  "<p style = 'color: red'>Der Manager versteht nicht: $task!";
			foreach($backtrace as $back) {
 		 		$return .= $back['class'] ." ". $back['function'].'<br />';
 			}
 			$return .= '</p>';
		}
		return $return;
	} else {return $this -> start_shop();}
}

function start_shop() {
		if($this -> settings[$this -> language]['shopName'] || $_POST['shopName']){
			$return.= $this -> decorator -> make_administrators_menu();
			return $return;
		}
		else {
			return $this -> offer_shop_making();}
	}
	

function save_settings(){
		global $contentFile,$c, $position,$h,$s, $sn;
		
		if($_POST['published'] == 'false') {
			$content = '<h1>'.$this->settings[$this -> language]['shopName'].'</h1>#CMSimple hide# #CMSimple $output .= display_shop();#';
			$c[$s] = $content;
			$this->settings['published']='false';
			$this->settings[$this -> language]['published']='false';
			$this -> save_named_array_to_file($this -> settingsFile, $this -> settings, '$zShopSettings');
			$this -> contentmanager -> save_the_new_content();
			return;
		}else {$content = '#CMSimple $output .= display_shop();#';
				if(isset($_POST['shopName'])){
					$newName = trim($_POST['shopName']);
					$url = urlencode($newName);
					$url = str_replace('+','_',$url);
					$this->settings[$this -> language]['url']=$url;
					$this->settings[$this -> language]['shopName']=$newName;
					$newContent = "<h1>".$newName."</h1>$content";
				}
				$shopIndex = count($h);			// Standard: Shop als letzter Menu-Punkt
				if(isset($_POST['shopAtIndex']))
					{$shopIndex = $_POST['shopAtIndex'];}
				if($shopIndex > $s) {
					array_splice($c, $shopIndex,0,$newContent);
					unset($c[$s]);
				}
				if($shopIndex < $s) {
					array_splice($c, $shopIndex,0,$newContent);
					unset($c[$s+1]);
				}
				
				foreach((array_keys($_POST)) as $key) {
					if(isset($this->settings[$this -> language][$key])) {
						$this->settings[$this -> language][$key] = trim($_POST[$key]);
					}
					if(isset($this->settings[$key])) {
						$this->settings[$key] = trim($_POST[$key]);
					}
				}
				if($_POST['cos_url']) {
					$cos_url = $_POST['cos_url'];
				}
				$this->settings[$this -> language]['cos_url']=$cos_url;
				$this -> save_named_array_to_file($this -> settingsFile, $this -> settings, '$zShopSettings');
				if(isset($_POST['shopName'])) { // wenn nicht, hat sich auch am Content nix geändert (vielleicht sollte man dieses settings-zeug lieber etwas verteilen?)
				$this -> contentmanager -> save_the_new_content();
				}
			}
		}
function save_financial_settings() {
			$shipping_prices = $_POST['shipping'];
			$shipping_labels = $_POST['shippingLabels'];
			if($_POST['show_netto']=='on') {
				$this->settings['show_netto'] = 'true';
			} else {$this->settings['show_netto'] = 'false';}
			if($_POST['no_shipping_sum']) {
				$this->settings['forwarding_expenses_up_to']['sum']=sprintf("%.2f",str_replace(",",".",$_POST['no_shipping_sum']));
			}
			if($_POST['no_shipping_items']) {
				$this->settings['forwarding_expenses_up_to']['items']=sprintf("%.0f",$_POST['no_shipping_items']);
			}
			if($_POST['charge_for_shipping']) {
				$this->settings['charge_for_shipping']=$_POST['charge_for_shipping'];
			}
			$i=1;
			foreach($shipping_prices as $price) {
				$this->settings['shipping'][$i]=sprintf("%.2f",str_replace(",",".",$price));
				$i++;
			}
			for($i = 1; $i < 4; $i++) {
				$this->settings['vat_area'][$i] = 'off';
				
			}
			
			foreach($_POST['vat_area'] as $key => $vat) {
				$this->settings['vat_area'][$key] = $vat;
			}
			if($_POST['shipping_1']) {
				$this->settings[$this -> language]['shipping_1']=$_POST['shipping_1'];
			} else {$this->settings[$this -> language]['shipping_1']='';}
			if($_POST['shipping_2']) {
				$this->settings[$this -> language]['shipping_2']=$_POST['shipping_2'];
			} else {$this->settings[$this -> language]['shipping_2']='';}
			if($_POST['shipping_3']) {
				$this->settings[$this -> language]['shipping_3']=$_POST['shipping_3'];
				} else {
					$this->settings[$this -> language]['shipping_3']='';
					$this->settings['shipping'][3] = '';
					$this->settings['vat_area'][3] = '';
			}
		
			$this->settings['dont_deal_with_taxes']='false';
			if($_POST['dont_deal_with_taxes']=='true') {
				$this->settings['dont_deal_with_taxes']='true';
			}
			if($_POST['vat_default']) {
				$this->settings['vat_default']=$_POST['vat_default'];
			}
			if($_POST['vat_full']) {
				$this->settings['vat_full']=sprintf("%.2f",str_replace(",",".",$_POST['vat_full']));
			}
			if($_POST['vat_reduced']) {
				$this->settings['vat_reduced']=sprintf("%.2f",str_replace(",",".",$_POST['vat_reduced']));
			}
			if($_POST['minimum_order']) {
				$this->settings['minimum_order']=sprintf("%.2f",str_replace(",",".",$_POST['minimum_order']));
			}
			if($_POST['default_currency'] == 'other') {
				$this -> settings['default_currency'] = addslashes(trim($_POST['other_currency']));
			} else {
				$currency = ($_POST['default_currency']);
				if($currency !== '&euro;') {$currency = htmlentities($currency);}
				$this -> settings['default_currency'] = $currency;
			}
			$currency = $this -> settings['default_currency'];
			if($currency == '&euro;') {$currency = 'EUR';}
			if($currency == '&pound;') {$currency = 'GBP';}
			if($currency == '&yen;') {$currency = 'JPY';}	
			if($currency == '$') {$currency = 'USD';}	
			$paypal_currencies = array('AUD','CAD','EUR','GBP','JPY','USD','NZD','CHF','HKD','SGD','SEK','DKK','PLN','NOK','HUF','CZK','ILS','MXN');
			if(in_array($currency,$paypal_currencies)) {
				$this->settings['paypal_currency'] = $currency;
			}
			$this -> save_named_array_to_file($this -> settingsFile, $this -> settings, '$zShopSettings');
			return $this -> decorator -> make_the_financial_settings($this -> settings, $this -> labels);
}

function save_payment_modes(){
	
	$modes = array('on_account', 'cash_on_delivery', 'cash_in_advance', 'pay_pal');
	foreach($modes as $mode) {
		if(isset($_POST[$mode])) {
			$this -> settings['payment'][$mode] = 0;
			if(isset($_POST[$mode]['enabled'])) {
				$this -> settings['payment'][$mode] = 1;
			}
			if(isset($_POST[$mode]['fee'])				) 
				{
				$fee = sprintf("%.2f",str_replace(',','.',$_POST[$mode]['fee']));
				
				if(is_numeric($fee)){ 
					$this -> settings['payment_fee'][$mode] = $fee;
				}
			}
		}
	}
	if(isset($_POST['paypal_email'])) {
		$this-> settings['paypal_email'] = $_POST['paypal_email'];
	} 
	if(isset($_POST['paypal_currency'])) {
		$this-> settings['paypal_currency'] = $_POST['paypal_currency'];
	} 
	if(strlen(trim($this -> settings['paypal_email'])) == 0) {
		$this -> settings['payment']['pay_pal'] = 0;
	}
	$this -> save_named_array_to_file($this -> settingsFile, $this -> settings, '$zShopSettings');
	return $this -> decorator -> make_payment_modes_inputs($this -> settings);
}

function save_language_changes() {
		$string = "<?php\n";
		foreach($this->buttons as $key=>$value) {
			if(is_array($value)) {
				foreach($value as $k => $val) {
				$string .= "\n".'$lang[\'buttons\'][\''.$key.'\'][\''.$k.'\']=\''.addslashes($val).'\';';
				}
			} else {
			$string .= "\n".'$lang[\'buttons\'][\''.$key.'\']=\''.addslashes($value).'\';';
			}
		}
		$string .= "\n";
		foreach($this->headings as $key=>$value) {
			if(is_array($value)) {
				foreach($value as $k => $val) {
					$string .= "\n".'$lang[\'headings\'][\''.$key.'\'][\''.$k.'\']=\''.addslashes($val).'\';';
				}
			} else {
			$string .= "\n".'$lang[\'headings\'][\''.$key.'\']=\''.addslashes($value).'\';';
			}
		}
		$string .= "\n";
		foreach($this->labels as $key=>$value) {
			if(is_array($value)) {
				foreach($value as $k => $val) {
					$string .= "\n".'$lang[\'labels\'][\''.$key.'\'][\''.$k.'\']=\''.addslashes($val).'\';';
				}
			} else {
			$string .= "\n".'$lang[\'labels\'][\''.$key.'\']=\''.addslashes($value).'\';';
			}
		}
		$string .= "\n";
		foreach($this->hints as $key=>$value) {
			if(is_array($value)) {
				foreach($value as $k => $val) {
					$string .= "\n".'$lang[\'hints\'][\''.$key.'\'][\''.$k.'\']=\''.addslashes($val).'\';';
				}
			} else {
			$string .= "\n".'$lang[\'hints\'][\''.$key.'\']=\''.addslashes($value).'\';';
			}
		}
		$string .= "\n?>";
		$fh = @fopen($this->languageFile,"w");
		fwrite($fh,$string);
		fclose($fh);
	}

function save_named_array_to_file($file,$data,$name){
		$save = "<?php\n";
		foreach($data as $key => $value){
			$row = $name."['". $key."']";
			if(!is_array($value)){
			$row .= "='".addslashes($value)."';\n";}
			else {
				$row ='';
				foreach($value as $k => $t){
					$row .= $name."['". $key."']"."['$k']='".addslashes($t)."';\n";
					}
			}
			$save .= $row;
		}
		$save.='?>';
		$fh = @fopen($file,"w");
		fwrite($fh,$save);
		fclose($fh);
		$this->settings=$data;
		
	}

function shop_settings() {
	global $pth;
	if(!is_writeable($pth['folder']['plugins']."wellrad".'/data/catalogue.inc')) {
		$warning = "<p class='warn'>". $this->hints['catalogue_needs_write_permission']."</p>";
	}
	if(!is_writeable($this->settingsFile)) {
		$warning .= "<p class='warn'>". $this->hints['settings_needs_write_permission']."</p>";
	}
	if($warning){
		return $warning;
	}
	$task = $_POST['settings_task'];
	if(!$task) {$task = 'make_the_main_settings';}
	if($task) {
		$return = $this -> decorator -> prepare_the_form_for($task);
	} else {$return = '<p style="color: red">manager -> shop_settings() weiß nicht, was er tun soll!</p>'; }
	return $return;
}

function administrate_products($task) {
	$task = 'list_products'; //als Standard
	
	if(isset($_POST['product_administration_task'])) {
		$task = $_POST['product_administration_task'];
	}
	$standard_category = $this -> catalogue -> category_for_the_left_overs[$this -> language];
	if(!isset($standard_category)) {
		$standard_category = $this -> settings[$this -> language]['category_for_left_over_products'];
	}
	
	$return = '<p style=\"color\" red>manager -> administrate_products versteht das nicht: '.$task;
	if($task == 'list_products') {
		$return = '';
		$products = $this -> catalogue -> products;
		if($this->settings['use_categories']=='true') {
				$chosen_category = 'all_categories';
				if(isset($_POST['chosen_category']) && ($_POST['chosen_category'] != Null)) {
					$chosen_category = $_POST['chosen_category'];
				}
				if($chosen_category <> 'all_categories') {
					$products = $this -> get_products_of_chosen_category($chosen_category);
				}
			$return .= $this -> decorator -> create_category_selector_form($this->catalogue->categories[$this -> language], $standard_category);
		}
		$return .= $this -> decorator -> list_products($products);
	} 
	if($task == 'add_product') {
		$count_products = count($this -> catalogue -> products);
		$categories = $this -> catalogue -> categories[$this -> language];
		$return = $this -> decorator -> make_product_form(null, $categories, $count_products);
	}	
	if($task == 'edit_categories') {
		$this -> edit_categories();
		$categories = $this -> catalogue -> categories[$this -> language];
		$left_over_category = $this -> catalogue -> category_for_the_left_overs[$this -> language];
		$default_category = $this -> catalogue -> default_category[$this -> language];
		$return = $this -> decorator -> make_categories_edit_form($categories, $left_over_category, $default_category);
	}	
	return $return;
}

/**
 * gibt einen Array mit allen Produkten der gewählten Kategorie $category zurück.
 * 
 *
 * @param unknown_type $category
 * @return unknown
 */
function get_products_of_chosen_category($filter){
	$products = $this -> catalogue -> products;
	$categories = $this -> catalogue -> categories[$this -> language];
	if(empty($category)) {$category = 'all_categories';}
	$filtered = array();
	if($filter ==  'left_overs'){
			foreach($products as $product) {
					if(count($product -> categories[$this -> language])< 1) {
								 $filtered[] = $product;
					}
				}
			}
			else {
				foreach($products as $product) {
					if(in_array($filter,$product->categories[$this -> language])){	
						 $filtered[] = $product;
					}
				}
			}
			$categories = $this -> catalogue -> categories[$this -> language];
	return $filtered;
}

function show_simpleShop_help() {
	if(file_exists($this -> help_path.$this -> language."_help.html")) {
		$return = "<p>". $this -> hints['help']."<a href='". $this -> help_path.$this -> language."_help.html'"." target = '_blank' >".$this -> buttons['show_simpleShop_help']."</a>.</p>";
		
	} else { $return = "<p>Sorry! This installation of wellrad doesn't offer any help in your language.</p>"
	."<p>Perhaps the <a href = \"".$this -> help_path."en_help.html"."\" target = \"_blank\"> english help</a> might assist you?</p>";}
	
	
	return $return;
}

function move_product_up(){
		$current_index = $_POST['counter'];
		$swap_index = ($this -> catalogue -> products[$current_index -1] -> counter);
		return $this -> swap_product_placements($current_index, $swap_index);
}
	
function move_product_down(){
		$current_index = $_POST['counter'];
		$swap_index = ($this -> catalogue -> products[$current_index +1] -> counter);
		return $this -> swap_product_placements($current_index, $swap_index);
}
	
function swap_product_placements($current_index, $swap_index){
		$swap = $this->catalogue->products[$swap_index];
		$current = $this->catalogue->products[$current_index]; 
		$current->counter = $swap_index;
		$swap->counter = $current_index;
		$this->catalogue->products[$current_index] = $swap; 
		$this->catalogue->products[$swap_index] = $current;
		$this->catalogue-> save();
		$this -> catalogue = new Catalogue($this -> separator);
		return $this -> administrate_products('list_products');
}

function edit_product() {
	$counter = $_POST['counter'];
	$product = $this -> catalogue -> products[$counter];
	$categories = $this -> catalogue -> categories[$this -> language];
	return $this -> decorator -> make_product_form($product, $categories);

}

function save_product($product_index) {
		$product_index = $_POST['product_index'];
		if(!$product_index) {
			$prod = new Product();
		} else {$prod = $this -> catalogue -> products[$_POST['product_index']];}
		$name = trim($_POST['name']);
		if($name == '') {$name = 'A product with no name!';}
		$prod -> names[$this -> language]= $name;
		$prod -> descriptions[$this -> language] = $_POST['description'];
		$price= 0;
		$price = $_POST['price'];
		$price = str_replace(',','.',$price);
		$prod -> price = sprintf("%.2f",$price);
		$prod -> vat = $_POST['vat'];
		$prod -> categories[$this -> language] = $_POST['product_categories'];
		$prod -> previewPicture = $_POST['preview_pic'];
		$prod -> productPages[$this -> language] = $_POST['productPages'];
		if($product_index){
		$this->catalogue -> products[$product_index] = $prod;
		}else {$this->catalogue -> products[] = $prod;}
		$this->catalogue-> save();
		$this -> catalogue = new Catalogue($this -> separator);
		return $this -> administrate_products();
}
function delete_product() {
		$products = $this ->  catalogue->products;
		$product = $products[$_POST['counter']];
		unset($this->catalogue->products[$_POST['counter']]);
		$this -> catalogue -> save();
		$return = "<p><b>&raquo;".$product->names[$this -> language]."&laquo; " . $this -> labels['was_deleted']. "</b></p>";
		$this -> catalogue = new Catalogue($this -> separator);
		$return .= $this -> decorator -> list_products($this -> catalogue -> products);
		return $return;
	}	

function edit_categories() {
	if(isset($_POST['move_this_up'])) {
		$index = $_POST['move_this_up'];
		$swap = $this -> catalogue -> categories[$this -> language][$index -1];
		$this -> catalogue -> categories[$this -> language][$index -1] = $this -> catalogue -> categories[$this -> language][$index];
		$this -> catalogue -> categories[$this -> language][$index] = $swap;
		$this -> catalogue -> save();
		$this -> catalogue = new Catalogue($this -> separator);
	}
	if(isset($_POST['move_this_down'])) {
		$index = $_POST['move_this_down'];
		$swap = $this -> catalogue -> categories[$this -> language][$index + 1];
		$this -> catalogue -> categories[$this -> language][$index + 1] = $this -> catalogue -> categories[$this -> language][$index];
		$this -> catalogue -> categories[$this -> language][$index] = $swap;
		$this -> catalogue -> save();
		$this -> catalogue = new Catalogue($this -> separator);
	}
		
	if(isset($_POST['old_category'])){
		$current_category = $this -> catalogue -> categories[$this ->language][$_POST['category_index']];
		if(strlen(trim($_POST['old_category'])) == 0) {
			$this -> catalogue -> delete_category($this -> language, $_POST['category_index']);
			} else {
		$this -> catalogue -> rename_category($this ->language, $_POST['category_index'], $_POST['old_category']);
		$this -> catalogue = new Catalogue($this -> separator);
		}
		
	}
	if(isset($_POST['new_category'])){
		if(strlen(trim($_POST['new_category'])) > 0) {
		$this -> catalogue -> categories[$this -> language][] = $_POST['new_category'];
		$this -> catalogue -> save();
		$this -> catalogue = new Catalogue($this -> separator);
		} 	
	}
	if(isset($_POST['left_over_category'])){
		if(strlen(trim($_POST['left_over_category'])) > 0) {
		$this -> catalogue -> category_for_the_left_overs[$this -> language] = $_POST['left_over_category'];
		$this -> catalogue ->save();
		$this -> catalogue = new Catalogue($this -> separator);
		}
	}
	if(isset($_POST['default_category'])){
		if(strlen(trim($_POST['default_category'])) > 0) {
		$this -> catalogue -> default_category[$this -> language] = $_POST['default_category'];
		$this -> catalogue -> save();
		$this -> catalogue = new Catalogue($this -> separator);
		}
	}
}

function offer_shop_making() {
	$return = $this -> decorator -> prepare_the_form_for('offer_shop_making');
	return $return;
}

function open_a_shop(){
		$shopName = $_POST['shopName'];
		if(!$shopName){$shopName = "A shop with no name";}
		if($_POST['shopAtLast'] == 'false'){
			$shopAtIndex = $_POST['shopAtIndex'];
		}
		$url = urlencode($shopName);
		$url = str_replace('+','_',$url);
		$this -> settings[$this -> language]['url'] = $url;
		$this -> settings[$this -> language]['shopName'] = addslashes($shopName);
		$this -> settings[$this -> language]['published'] = 'true';
		$this -> decorator -> settings = $this -> settings;
		$this -> save_named_array_to_file($this -> settingsFile, $this -> settings, '$zShopSettings');
		$this -> contentmanager -> insert_page($shopName, '#CMSimple $output.=display_shop();#','1',$shopAtIndex);
		$this -> contentmanager -> save_the_new_content();
	return	$this->shop_settings();
	}
}
?>