<?php
/*
 *  Ich bin zuständig für die Html-Oberfläche des Frontends
 *
 *
 *
 */
class ShopDecorator {
	var $buttons, $headings, $labels, $hints, $settings, $zUrl, $settingsFile, $image_folder;
	function ShopDecorator() {
		global $sl, $pth, $sn;
		$zShopSettings = array();
		include $pth['folder']['plugins']."wellrad/config/shopsettings.php";
		include $pth['folder']['plugins'].'/wellrad/zShopLanguages/'.$sl.'.php';
		include_once $pth['folder']['plugins']."/wellrad/collaborators/contentmanager.inc";
		include_once $pth['folder']['plugins']."/wellrad/collaborators/htmlwriter.inc";
		$this -> language = $sl;
		$this -> buttons = $lang['buttons'];
		$this -> labels = $lang['labels'];
		$this -> headings = $lang['headings'];
		$this -> hints = $lang['hints'];
		$this -> settings = $zShopSettings;
		$this -> zUrl = $sn."?".$zShopSettings[$sl]['url'];
		$this -> contentmanager = new ContentManager($pth['file']['content']);
		$this -> writer = new HtmlWriter($sl);
		$this -> image_folder = $pth['folder']['plugins']."/wellrad/images/";

	}

	function create_the_cart_preview_heading($summe, $heading, $button_label) {
		$return ="\n<div id=\"cartPreview\" >";
		$return .= "\n<span style = \"text-align: right;\">";
		$return .= "\n\t<form  action=\"".$this -> zUrl."\" method=\"post\" style=\"display: inline;\">";
		$return .= "\n\t\t<div style=\"text-align: right; padding: 0px; margin: 0px;\" ><input type=\"submit\" class=\"shopButton\" value=\"".$button_label."\" /></div>";
		$return .= $heading."". $this->writer->format_the_money($summe) ."&nbsp;".$this -> settings['default_currency'];
		$return .= "\n\t\t<input type=\"hidden\" name=\"PHPSESSID\" value=\"".session_id()."\" />";
		$return .= "\n\t\t<input type = \"hidden\" name= \"order_step\" value=\"offer_to_order\" />";
		$return  .= "\n\t</form></span>";
		return $return;
	}

	function create_table_row_for_cart_preview($product, $price, $amount, $css_class){
		$lang = $this->language;

		if(!isset($product ->names[$lang])) {
			$langs = array_keys($this -> names);
			$lang = $langs[0];
		}
		$name = $product -> names[$lang];
		if((isset($product -> productPages[$lang])) && (count($product -> productPages[$lang])> 0)) {
			$name = "<a href=\"" . $product -> productPages[$lang][0] . "\">$name</a>";
		}
		$return = "\n\t<tr class=\"$css_class\">\n\t\t<td style=\"text-align: right;\">";
		$return .= "$amount x</td>";
		$return .= "\n\t\t<td>".$name."</td>";
		$return .= "\n\t\t<td style =\"text-align: right; white-space: nowrap;padding-right: 1em;\">&agrave; ".  $this->writer->format_the_money($price)."&nbsp;".$this -> settings['default_currency']."</td>";
		$return.= "\n\t\t<td style =\"text-align: right;font-weight: bold;\">". $this->writer->format_the_money($price * $amount) . "&nbsp;".$this -> settings['default_currency']."</td></tr>";
		return $return;
	}

	function create_the_cart_heading($summe, $heading, $button_label) {
		$return ="\n<h5>".$this -> headings['order_overview']."</h5>";
		$return .= "\n<div id=\"steps\">\n\t<span class=\"now\">1.&nbsp;".$this->hints['step1']."</span>\n\t<span>2. ".$this->hints['step2']."</span>\n\t<span>3. ".$this->hints['step3']."</span>\n</div>\n";
		$return .= "<p>".$this -> hints['edit_cart']."</p>";
		$return .= "\n<table id =\"cart_table\" cellspacing=\"0px\" cellpadding=\"0px\">";
		return $return;
	}

	function create_table_row_for_cart($item, $price, $amount, $css_class) {
		$lang = $this->language;
		if(!isset($item ->names[$lang])) {
			$langs = array_keys($item -> names);
			$lang = $langs[0];
		}

		$name = $item -> names[$lang];
		if((isset($item -> productPages[$lang])) && (count($item -> productPages[$lang])> 0)) {
			$name = "<a href=\"" . $item -> productPages[$lang][0] . "\">$name</a>";
		}
		$return = "\n\t<tr class=\"$css_class\">\n\t\t<td>";
		$return .="\n\t\t\t<form action=\"$shop_url\" method=\"post\" style=\"text-align: right;\">";
		$return .= 	"\n\t\t\t\t<input type=\"text\" size=\"1\"  name=\"amount\" value=\"".$amount ."\" onChange=\"this.parentNode.submit()\" />";
		$return .= "\n\t\t\t\t<input type=\"submit\" value=\"ok!\" class=\"shopButton\" />";
		$return .= 	"\n\t\t\t\t<input type=\"hidden\"  name=\"task\" value=\"add_to_cart\" />";
		$return .= 	"\n\t\t\t\t<input type=\"hidden\"  name=\"order_step\" value=\"offer_to_order\" />";
		$return .= 	"\n\t\t\t\t<input type=\"hidden\"  name=\"cart_item\" value=\"".$item -> counter."\" />";
		$return .= "\n\t\t\t</form>\n\t\t</td>";
		$return .= "\n\t\t<td style =\"text-align: right; white-space: nowrap;padding-right: 1em;\">".$name."</td>";
		$return .= "\n\t\t<td style =\"text-align: right; white-space: nowrap;padding-right: 1em;\">&agrave; ".  $this->writer->format_the_money($price) ."&nbsp;".$this -> settings['default_currency']."</td>";
		$return.= "\n\t\t<td style =\"text-align: right;font-weight: bold;\">".  $this->writer->format_the_money($price * $amount) . "&nbsp;".$this -> settings['default_currency']."</td>\n\t</tr>";
		return $return;
	}

	function ask_for_shipping_area($charge) {
		$return = "\n\t\t<h5 class=\"shop\">".$this->headings['ask_for_the_destination']."</h5>";
		$shipping_labels['1'] = $this-> settings[$this->language]['shipping_1'];
		$shipping_labels['2'] = $this-> settings[$this->language]['shipping_2'];
		$shipping_labels['3'] = $this-> settings[$this->language]['shipping_3'];
		$test = 0;
		foreach($shipping_labels as $shipping) {
			if(strlen(trim($shipping))> 0){$test = $test + 1;}
		}
		if($test < 1) {return '';}
		if($charge == false) {
			foreach($shipping_labels as $key=>$shipping) {
				if(strlen(trim($shipping))==0) {
					$return .= '';
				}else {
					$checked = '';
					if($test == 1) {$checked = 'checked';}
					if($_SESSION['customer']->destination_area == "" && $key == 1) {$checked= 'checked';}
					if($_SESSION['customer']->destination_area == $shipping) {$checked = 'checked';}
					$association = $shipping.',0,'.$this->settings['vat_area'][$key];
					$return .= "\n\t\t<label><input name=\"shipping\" value=\"".$association."\" $checked type=\"radio\" />$shipping</label>";
					
				}
				if($this->settings['vat_area'][$key] == 'off' &&
				$this->settings['dont_deal_with_taxes'] !== 'true') {
					
					
					$return .= "<br />" . $this->hints['no_vat_export'];
				}
				$return .= "<br />";
			}
		}else {foreach($shipping_labels as $key=>$shipping) {

			if(strlen(trim($shipping))==0) {
				$return .= '';
			}
			else {	if($this->settings['shipping'][$key]==0) {
				$expenses = $this->hints['no_forwarding_expenses'];
			}
			else {
				$fee = $this->settings['shipping'][$key];
				if($this->settings['show_netto']=='true'){
					$fee = ($fee/(100+$this->settings['vat_full']))*100;
				}
				$expenses = $this->writer->format_the_money($fee). "&nbsp;".$this -> settings['default_currency'] . "&nbsp;". $this->labels['forwarding_expenses'];
			}
			$association = $shipping.','.$this->settings['shipping'][$key].','.$this->settings['vat_area'][$key];
			$checked = '';
			if($test == 1) {$checked = 'checked';}
			if($_SESSION['customer']->destination_area == "" && $key == 1) {$checked= 'checked';}
			if($_SESSION['customer']->destination_area == $shipping) {$checked = 'checked';}
			$return .= "\n\t\t<label><input name=\"shipping\" value=\"".$association."\" $checked type=\"radio\" />$shipping: $expenses</label>";
			$checked = '';
			}
			if($this->settings['vat_area'][$key] == 'off' 
				&& $this->settings['show_netto'] !== 'true'
				&& $this->settings['dont_deal_with_taxes'] !== 'true') {
					/*
					 * TODO: 
					 */
				$return .= "&nbsp;&ndash;&nbsp;" . $this->hints['no_vat_export'];
			}
			$return .= "<br />";
		}
		//$return .= "\n\t\t<p>".$this->hints['we_pay_the_shipping_from']."</p>";
		$return .= "\n\t\t<p>".$this->labels['forwarding_expenses_up_to']. " ".
		$this -> labels['items']. " ".
		$this->settings['forwarding_expenses_up_to']['items']. " ".
		$this->labels['or']. " ".
		$this -> labels['sum']. " ".
		$this->writer->format_the_money($this->settings['forwarding_expenses_up_to']['sum']). "&nbsp;".
		$this -> settings['default_currency']. ".".
					"</p>";
		}

		return $return;
	}

	function start_the_start_order_form() {
		$return = "\n\n\n\n<table class=\"cart_table\">\n\t<tr>\n\t\t<td style=\"vertical-align: bottom; \">";
		$return .= "\n\t\t<form action=\"\" method = \"post\">";
		$return .= "\n\t\t\t<input type=\"hidden\" name=\"task\" value=\"show_the_catalogue\" />";
		$return .= "\n\t\t\t<div><br /><input type=\"submit\" class=\"shopButton\" value=\"<< ".$this -> buttons['continue_shopping']."\" /></div>\n\t\t</form>\n\t</td>";
		$return .= "\n\t<td style=\"vertical-align: bottom; \">\n\t\t<form action=\"\" method = \"post\">";
		return $return;
	}

	function finish_the_start_order_form() {
		$return = "\n\t\t\t<input type=\"hidden\" name=\"order_step\" value=\"ask_for_order_data\" />";
		$return .= "\n\t\t\t<div style=\"text-align: right;\"><br /><input type=\"submit\" class=\"shopButton\" value=\"".$this -> buttons['order_now']." >>\" /></div>\n\t\t</form>\n\t</td>";
		$return .= "\n\t</tr>\n</table>\n\n\n";
		return $return;
	}

	function create_header_for_products_table($categories, $standard_category, $there_are_left_overs, $filter) {
		if(($this->settings['use_categories']=='true')
		&& (count($categories)> 0)) {
			$return = $this -> create_category_selector_form($categories, $standard_category, $there_are_left_overs, $filter);
		}
		$return .="\n<table id=\"productsTable\">";
		$return .= "\n<colgroup>"
		."\n\t<col />"
		."\n\t<col />"
		."\n</colgroup>"
		."\n<thead>\n<tr>"
		."\n\t<th></th>"
		."\n\t<th>&nbsp;</th>"
		."\n</tr>\n</thead>"
		."\n<tbody>";
		return $return;
	}
	/**
	 * Select-Form für die Kategorien schreiben
	 * dafür brauche ich folgende Informationen:
	 * $categories -
	 *
	 */
	function create_category_selector_form($categories, $standard_category, $there_are_left_overs, $filter) {
			
		$return = "\n\t<form method = \"post\" action=\"\" class=\"inline\" id = 'wellrad_cats'>";
		$return .= "\n\t<select  name=\"chosen_category\" ";
		$return .= "onchange=\"this.parentNode.submit(); \"";
		$return .= ">";
		echo $test;

		if($this -> settings['allow_show_all']) {
			$return .= "\n\t<option value =\"".$this->labels['all_categories']."\">".$this->labels['all_categories']."</option>";
		}
		foreach($categories as $category) {
			$selected = '';
			if($filter == $category) {
				$selected = 'selected';
				$heading = $category;
			}
			$return .= "\n\t<option value=\"$category\" $selected>$category</option>";
		}
		$selected = '';
		if($_POST['chosen_category'] == 'left_overs') {
			$selected = 'selected';
			$heading = $standard_category;
		}
		if($there_are_left_overs) {
			$return .= "\n\t<option value =\"left_overs\" $selected >".$standard_category."</option>";
		}
		$return .= "\n\t</select>&nbsp;\n<noscript><input type=\"submit\" class=\"shopButton\" value=\"[anzeigen]\" />\n</noscript>\n</form>\n";
		$return .="<h2>$heading</h2>";
		return $return;

	}
	function create_the_rows_for_products_table($products) {
		if(count($products)< 1) {
			return "<tr><td colspan=\"\">". $this -> hints['sold_out_1']. $_POST['chosen_category']. $this -> hints['sold_out_2']. "</td></tr>";
		}
		$lang = $this->language;
		foreach($products as $product) {
			if($this->settings['show_netto']=='true'){
				$price = $product->get_netto($this->settings['vat_full'], $this->settings['vat_reduced']);
			} else {$price = $product->price;}
			$image = $product -> get_the_preview_picture($lang);
			$return .= "\n\t<tr>\n\t\t<td style=\"vertical-align: top;\"><br /><br />$image\n\t\t</td>";
			$name = $product->get_the_name($lang);
			$link = '';
			if(isset($product -> productPages[$lang][0])) {
				$name = "<a class=\"product_heading\" href =\"".$product -> productPages[$lang][0]." \">$name</a>";
				$link = $product -> get_the_details_link($lang,$this->labels['product_info']);
			}
			$price = $this->writer->format_the_money($price);
			$decimals = substr($price, -2);
			$price = substr_replace($price, '<sup>'.$decimals.'</sup>',-2);
			$return .= "\n\t\t<td>\n\t\t\t<div class=\"productTitle\">\n\t\t\t\t<b>". $name."</b>\n\t\t\t</div>";
			$return .= "\n\t\t\t<div class=\"productDescription\">\n\t\t\t<br />".nl2br($product -> get_the_description($lang))."\n\t\t\t\n\t\t\t</div>";
			$return .= "\n\t\t\t<br />$link\n\t\t\t";
			$return .= "\n\t\t\t<div style=\"text-align: right;\">\n\t\t\t\t<b>".$this->labels['price']."&nbsp;".  $price ."&nbsp;".$this -> settings['default_currency']."</b>";
			$return .= $this->add_price_infos($product);
			$reurn .= "<br /><br />\n\t\t\t</div>";
			$return .= "\n\t\t\t<div style=\"text-align: right; padding-bottom: 1ex;  border-bottom: 1px #444577 dotted;\">\n\t\t\t<form action=\"\" method=\"post\" >";
			$return .= "\n\t\t\t\t<input type=\"text\" size=\"2\" style=\"display: inline; width: 1.5em;\" name=\"amount\" value=\"1\" />";
			$return .= "\n\t\t\t\t<input type=\"hidden\" name=\"task\" value=\"add_to_cart\" />";
			$return .= "\n\t\t\t\t<input type=\"hidden\" name=\"chosen_category\" value=\"".$_POST['chosen_category'] ."\" />";
			$return .= "&nbsp;x&nbsp;<input type=\"hidden\" name=\"cart_item\" value=\"".$product -> counter ."\" />";
			$return .= 	"\n\t\t\t\t<input type=\"submit\" class=\"shopButton\" name=\"\" value=\"".$this -> buttons['add_to_cart']."\" />\n\t\t\t</form>\n\t\t\t</div>";
			$return .= "\n\t\t</td>\n\t</tr>";
		}
		return $return;
	}

	function create_footer_for_products_table() {
		$return .= "\n</tbody>\n</table>\n";
		return $return;
	}
	function create_the_order_data_form(){
		$return = "\n<div id=\"steps\">\n\t<h5>".$this->headings['order_overview']."</h5>\n\t\t<span>1. ".$this->hints['step1']."</span><span class=\"now\">2. ".$this->hints['step2']."</span><span>3. ".$this->hints['step3']."</span>\n</div>";
		$return .= '<p>'.$this->hints['ask_for_contact_data'].'</p>';
		$return .= "\n\t<form action=\"\" method=\"post\">";
		$return .= "\n\t<input type=\"hidden\" name=\"order_step\" value=\"check_the_order_data\" />";
		$return .= $this -> create_the_contact_data_inputs();
		$return .= $this -> create_the_payment_mode_inputs();
		$return .= $this -> create_the_cos_confirmation_input();
		$return .= $this -> create_the_annotation_input();
		$return .= "\n\t<p style= \"text-align: right;\">";
		$return .= "\n\t<input type=\"submit\" value=\"".$this -> buttons['next']."\" class=\"shopButton\" />\n\t</p>";
		$return .= "\n\t</form>";
		return $return ;
	}
	function create_the_contact_data_inputs($just_for_these){
		$fields = array('first_name'=>34,'last_name'=>34,'street'=>34,'zip_code'=>5,'city'=>25,'e_mail' => 34);
		if(isset($just_for_these)) {
			foreach($just_for_these as $this_one){
				$new_fields[$this_one] = $fields[$this_one];
			}
			$fields = $new_fields;
		}
		$return = "\n<h4>".$this->headings['customers_adress']."</h4>\n";
		$input = new Input();
		$class='data_form';
		foreach($fields as $name => $size) {
			if($name == 'city') {
				$class = 'inline_form';
			} else {

				$class = 'data_form';

			}
			$return .= "\n<label class=\"$class\" for=\"$name\">". $this -> labels[$name] . "</label>";
			if($_SESSION['customer']) {
				$value = $_SESSION['customer'] ->$name ;
			}
			if($name == 'zip_code') {
				$class = 'inline_form';
			} else {

				$class = 'data_form';

			}
			$input -> properties = array('type' => 'text',
									 'class' => $class,
									 'name' => $name,
									 'value' => $value,
									 'id'=> $name,
									 'size' => $size,
			'width' => $width);
			if($name == 'city') {
				$input -> properties['class'] = 'shorter';
			}

			$return .=	$input -> display_yourself() ;
			if($name !== 'zip_code') {
				$return .= "<br />";
			}

		}

		$return .= "\n\t";
		return $return ;
	}
	function create_the_cos_confirmation_input(){
		$return= '<h4>'.$this->headings['confirm_cos'].'</h4>';
		$cos_url = $this -> settings[$this ->language]['cos_page'];
		$cos_page_name = $cos_url;
		$cos_url = str_replace(' ', '_', $cos_url);
		$cos_url = urlencode($cos_url);
		$checked='';
		$return .= "<p>";
		if($_SESSION['customer']->cos_confirmed =='on') {
			$checked= 'checked';
		}
		$return .= "\n<input type=\"checkbox\" name=\"cos_confirmed\" $checked />";
		$hint = $this->hints['cos_confirmation'];
		$name = $this ->  hints['cos_name'];
		if(strlen($cos_url) > 0) {
			$link = "<a href=\"?$cos_url\">$name</a>";
			$hint = str_replace($name, $link, $hint);
		}
		$return .= $hint;
		$return .= "</p>";
		return $return;
	}
	function create_the_payment_mode_inputs(){
		foreach($this->settings['payment'] as $mode => $enabled) {
			if($enabled) {$offered_modes[]= $mode;}
		}
		if(count($offered_modes)==0) {
			$return .= 'Ooops! Keine Zahlweise angegeben!';
			return $return;
		}
		$input = new Input();
		$input -> properties = array('type'=>'radio','name'=>'payment_mode');
		$checked='checked';
		if(count($offered_modes)==1) {
			$input->properties['value']=$offered_modes[0];
			$input->properties['checked']=$checked;
			$return .= "<p><h4 style=\"display: inline;\">".$this->hints[only_one_payment_mode]."</h4>";
			$return .= "<label>".$input -> display_yourself().$this->labels[$offered_modes[0]]. "</label>.</p>";
			return $return;
		}
		$return = "\n\t".'<h4>'.$this->headings['choose_payment_mode'].'</h4>';
		foreach($offered_modes as $mode) {
			unset($input -> properties['checked']);
			unset($expenses);
			if($_SESSION['customer'] -> payment_mode == $mode) {
				$input->properties['checked']= 'checked';
			}
			$input -> properties['value']=$mode;
			$return .= "\n<label>".$input -> display_yourself();
			$label = $this->labels[$mode];
			$fee = $this -> settings['payment_fee'][$mode];
			if($this->settings['show_netto'] == 'true') {
				$factor = (100 + $this->settings['vat_full'])/100;
				$fee = $fee/$factor;
			}
			$label = $this->labels[$mode];
			if(is_numeric($fee)) {
				if($fee > 0) {
					$fee = $this->writer->format_the_money($fee);
					$expenses = " (". $this -> labels['fee'] . ": ". $fee ."  " . $this -> settings['default_currency'].")";
				}
				if($fee < 0) {
					$fee = $this->writer->format_the_money($fee*-1);
					$label = "<b>".$label;
					$expenses = " (". $this -> labels['reduction'] . ": ".$fee ."  " . $this -> settings['default_currency'].")</b>";
				}
			}
			if($mode == 'pay_pal') {
				$label = "<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<image style=\"margin-top: -1.5ex;\" src=\"". $this -> image_folder . "paypal_solutions.gif" ."\" /><br />";
				$expenses = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . $expenses;
			}
			$return .= $label.$expenses."</label><br />";
		}
		return $return;
	}

	function create_the_annotation_input() {
		$return = "\n\t\t".$this->hints['ask_for_annotation'];
		if($_SESSION[customer]) {$content=$_SESSION['customer']->annotation;}
		$return .= "\n\t<textarea name=\"annotation\" cols=\"50\" rows = \"6\">$content</textarea>";
		return $return;
	}

	function create_form_for_missing_customer_data($missing_infos) {
		$return = "<div id=\"steps\"><h5>".$this->headings['order_overview']."</h5><span>1. ".$this->hints['step1']."</span><span class=\"now\">2. ".$this->hints['step2']."</span><span>3. ".$this->hints['step3']."</span></div>";
		$return .= '<p>'.$this->hints['ask_for_contact_data'].'</p>';
		$return .= "\n\t<form action=\"\" method=\"post\">";
		$return .= "\n\t<input type=\"hidden\" name=\"order_step\" value=\"check_the_order_data\" />";
		if(isset($missing_infos['contact'])) {
			$return .= $this -> create_the_contact_data_inputs($missing_infos['contact']);
		}
		if(isset($missing_infos['cos_confirmed'])) {
			$return .= $this -> create_the_cos_confirmation_input();
		}
		if(isset($missing_infos['payment_mode'])) {
			$return .= $this -> create_the_payment_mode_inputs();
		}
		$return .= "\n\t<p style= \"text-align: right;\">";
		$return .= "\n\t<input type=\"submit\" value=\"".$this->buttons['next']."\" class=\"shopButton\" />\n\t</p>";
		$return .= "\n\t</form>";
		return $return ;
	}

	function create_customers_data_table(){
		$return = "\n<table>";
		$customer = $_SESSION['customer'];
		if($this->language == 'de') {setlocale(LC_TIME, "de_DE", "ge", "de");}
		$datum =strftime('%A, %d. %B %Y');
		$return .= "\n\t<tr><td>".$this->labels['date_of_order'].":&nbsp;&nbsp;</td><td>$datum</td></tr>";
		$return .= "\n\t<tr>\n\t\t<td style=\"vertical-align: top;\" >".$this->labels['delivery_adress'].":&nbsp;&nbsp;</td>\n\t\t<td>\n\t\t\t";
		$return .=	$customer->first_name . " ". $customer->last_name ."<br />\n\t\t\t";
		$return .=	$customer->street ."<br />\n\t\t\t";
		$return .=	$customer->zip_code . " ". $customer->city ."<br />\n\t\t\t";
		$return .=	$customer->e_mail ."<br />\n\t\t\t";
		$return .= "</td></tr>";
		$return .= "\n\t<tr><td>".$this->labels['destination_area'].":&nbsp;&nbsp;</td><td>".$customer->destination_area."</td></tr>";
		$return .= "\n\t<tr><td>".$this->labels['payment_mode'].":&nbsp;&nbsp;</td><td>".$this->labels[$customer->payment_mode]."</td></tr>";
		$return .= "\n\t<tr><td>".$this->labels['annotation'].":&nbsp;&nbsp;</td><td>".nl2br($customer->annotation)."</td></tr>";
		$return .= "\n</table>";
		return $return;
	}
	
	function create_customers_order_table($cart_items, $shipping, $fee, $shipping_vat, $fee_vat, $cart_netto, $summe, $vat){

		$return = "\n<table class=\"cart\" width=\"100%\" border = '0' rules=\"all\" cellspacing=\"0px\" cellpadding=\"0px\">\n";
		$return .= $this -> create_product_rows($cart_items);
		$i = count($cart_items) + 1;
		$class="even";
		if(is_integer($i/2)) {$class="odd";}
		$return .= "\n\t<tr class=\"$class\">\n\t\t<td></td>";
		$return .= "\n\t\t<td colspan=\"2\"><b>".$this -> labels['subtotal'].":&nbsp;&nbsp;</b></td>";
		if($this->settings['show_netto'] == 'true'){
			$temp_sum = $cart_netto; 
		}else {
			$temp_sum= $summe;
		}
		$return .= "\n\t\t<td style=\"text-align: right;\"><b>". $this->writer->format_the_money($temp_sum)."&nbsp;".$this -> settings['default_currency']."</b></td></tr>";

		if($fee !== 0.0) {
			$class = $this->switch_css_class($class);
			$return .= $this -> create_payment_fee_row($fee, $class);
		}

		if($shipping !== 0.0) {
			$class = $this->switch_css_class($class);
			$return .= $this -> create_shipping_fee_row($shipping, $class);
		}
		$summe = $summe + $fee + $shipping;
		if($this->settings['show_netto']=='true') {
			$summe = $summe + $shipping_vat + $fee_vat;
		}
		if($this->settings['dont_deal_with_taxes'] !== 'true'){
					
			$class = $this->switch_css_class($class);
			$return .= $this -> create_vat_rows($vat, $class);
		}
		
		if($_SESSION['customer']->vat_area == "off"
			&& $this->settings['dont_deal_with_taxes'] !== 'true'	
		){
			$summe = $summe - $vat['full'] - $vat['reduced'];
		}
		$class = $this->switch_css_class($class);
		
		$return .= "\n\t<tr class=\"$class\"><td></td><td colspan=\"2\"><b>".$this -> labels['total'].":</b></td><td style=\"text-align: right;\"><b>". $this->writer->format_the_money($summe)."&nbsp;".$this -> settings['default_currency']."</b></td></tr>";
		$return .= "\n</table>";
		if($this->settings['dont_deal_with_taxes']=='true') {
			$return .=  $this->hints['no_vat_bill'];
		}
		$return .= "\n<table style=\"width: 100%;\">\n\t<tr>\n\t\t<td>";
		$return .= "\n<form action=\"\" method=\"post\" style=\"display: inline;\">";
		$return .= "\n\t<input type=\"hidden\" name=\"order_step\" value=\"offer_to_order\" />";
		$return .= "\n\t<input type=\"submit\" class=\"shopButton\"  value=\"".$this->buttons['change_order']."\" />\n</form>\n</td>";
		$return .= "\n\t\t<td style = \"text-align: right;\" >";
		$return .= $this -> make_order_now_form($cart_items, $fee_vat);
		$return .="\n</td>";
		$return .= "\n\t</tr>\n</table>";
		
		return $return;

	}

	function switch_css_class($class){
		if($class == 'odd') {
			$class = 'even';
		}else{$class = 'odd';}
		return $class;
	}
	
	function create_product_rows($cart_items) {
		$class = 'even';
		foreach($cart_items as $item) {
				if(($item['product'])!==NULL) {
					$product = $item['product'];
					$amount = $item['amount'];
					$price = $item['price'];
					$return .= "\n\t<tr class = \"$class\">";
					$return .= "\n\t\t<td>". $amount ."</td>";
					$return .= "\n\t\t<td> x ".$product -> names[$this -> language] ."</td>";
					$return .= "\n\t\t<td> &agrave; ". $this->writer->format_the_money($price) ."</td>";
					$return .= "\n\t\t<td style=\"text-align: right;\">"
						. $this->writer->format_the_money($price * $amount) ."&nbsp;"
						.$this -> settings['default_currency']."</td>";
					$return .= "\n</tr>";
					$class = $this->switch_css_class($class);
				}
			}
			return $return;
	}
	
	function create_payment_fee_row($fee, $class){
		if($fee > 0) {$payment_fee_label = $this -> labels['fee'];}
		if($fee < 0) {$payment_fee_label = $this -> labels['reduction'];}
		$payment_fee_label .= " " . $this -> labels[$_SESSION['customer'] -> payment_mode];
		$return .= "\n\t<tr class=\"$class\"><td></td><td colspan=\"2\">"
				."<b>".$payment_fee_label.":</b></td><td style=\"text-align: right;\">"
				.$this->writer->format_the_money($fee)."&nbsp;".$this -> settings['default_currency']."</td></tr>";
		return $return;
		
	}

	function create_shipping_fee_row($shipping, $class) {
		$return = "\n\t<tr class=\"$class\"><td></td><td colspan=\"2\"><b>"
			.$this->labels['forwarding_expenses'].":</b></td><td style=\"text-align: right;\">"
			. $this->writer->format_the_money($shipping)."&nbsp;"
			.$this -> settings['default_currency']."</td></tr>";
			return $return;
		
	}
	function create_vat_rows($vat,$class){
		
		if($vat['full'] !== (float)0) {
				$taxes[]=  $this->writer->format_the_money($vat['full'])."&nbsp;".$this -> settings['default_currency'];
				$labels[]= $this->settings['vat_full']."&nbsp;%:";
			}
		if($vat['reduced'] !== (float)0) {
				$taxes[]= $this->writer->format_the_money($vat['reduced'])."&nbsp;".$this -> settings['default_currency'];
				$labels[]=$this->settings['vat_reduced']."&nbsp;%:";
			}

		$rows = count($taxes);
		$return = "\n\t<tr class=\"$class\">";
		$return .= "<td rowspan=\"".$rows."\"></td><td rowspan=\"".$rows."\" style=\"text-align: right;\">";
		
		if($this->settings['show_netto'] == 'true') {
			if($_SESSION['customer']->vat_area == 'off') {return;}
			$return .= $this -> create_add_vat_rows($taxes, $labels, $class);
			return $return;
		}
		if($_SESSION['customer'] -> vat_area == 'off'){
				$return .= $this -> create_subtract_vat_rows($taxes, $labels, $class);
				return $return;
		}
			
		$return .= $this -> create_included_vat_rows($taxes, $labels, $class);
		return $return;
	}
	
	function create_included_vat_rows($taxes, $labels, $class) {
		
		$return = $this -> labels['included_vat']."&nbsp;</td>";
		$return .= "<td style=\"text-align: right;\">".$labels[0]."&nbsp;".$taxes[0]."</td><td></td></tr>";		
		if(count($taxes)== 2){
				$return .= "<tr class=\"$class\"><td style=\"text-align: right;\">".$labels[1]."&nbsp;".$taxes[1]."</td><td></td></tr>";		
		}
		return $return;
	}
	function create_add_vat_rows($taxes, $labels, $class) {
		
		$return = $this -> labels['added_vat']."&nbsp;</td>";
		$return .= "<td style=\"text-align: right;\">".$labels[0]."</td>";
		$return .= "<td style=\"text-align: right;\">".$taxes[0]."</td></tr>";		
		if(count($taxes)== 2){
				$return .= "<tr class=\"$class\"><td style=\"text-align: right;\">".$labels[1]."</td>";
				$return .= "<td style=\"text-align: right;\">".$taxes[1]."</td></tr>";		
		}
		return $return;
	}
	function create_subtract_vat_rows($taxes, $labels, $class) {
		$return = $this -> labels['subtracted_vat']."&nbsp;</td>";
		$return .= "<td style=\"text-align: right;\">".$labels[0]."</td>";
		$return .= "<td style=\"text-align: right;\">-".$taxes[0]."</td></tr>";		
		if(count($taxes)== 2){
				$return .= "<tr class=\"$class\"><td style=\"text-align: right;\">".$labels[1]."</td>";
				$return .= "<td style=\"text-align: right;\">-".$taxes[1]."</td></tr>";		
		}
		return $return;
	}
	
	function make_order_now_form($cart_items, $fee_vat) {
		if($_SESSION['customer']->payment_mode == 'pay_pal') {
			return $this -> make_paypal_form($cart_items, $fee_vat);
		}
		$return .= "\n<form action=\"\" method=\"post\" style=\"display: inline;\">";
		$return .= "\n\t<input type=\"hidden\" name=\"order_step\" value=\"finish_the_order\" />";
		$return .= "\n\t<input type=\"submit\" class=\"shopButton\"  value=\"".$this->buttons['send_order']."\" />\n</form>";
		return $return;
	}

	function make_paypal_form($cart_items, $fee_vat) {
		$cart_handling = $_SESSION['customer']->forwarding_expenses + $_SESSION['customer'] -> fee; 
		if($_SESSION['customer']->vat_area == "off"	&& $this->settings['dont_deal_with_taxes'] !== 'true'){
			$cart_handling = $cart_handling - $fee_vat;
		}
		$language_codes = array(
			'Australian'=>'AU',
			'Chinese'=>'CN', 
			'English' => 'EN', 
			'French' => 'FR', 
			'German' => 'DE', 
			'Italian' => 'IT', 
			'Japanese' => 'JP', 
			'Spanish' => 'ES', 
			'United Kingdom' => 'GB');
		$my_lc = strtoupper($this->language);
		if($this->settings['paypal_currency']=='AUD') {$my_lc = 'AU';}
		if($this->settings['paypal_currency']=='GBP') {$my_lc = 'GB';}
		if(!in_array($my_lc, $language_codes)){$my_lc='EN';} 
		$return = "<form action=\"https://www.paypal.com/cgi-bin/webscr\" method=\"post\">";
		//$return = "<form action=\"https://www.sandbox.paypal.com/cgi-bin/webscr\" method=\"post\">";
		$return .= "\n\t<input type=\"hidden\" name=\"cmd\" value=\"_cart\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"upload\" value=\"1\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"business\" value=\"".$this->settings['paypal_email']."\">";
		$return .= "\n\t<input type=\"hidden\" name=\"currency_code\" value=\"".$this->settings['paypal_currency']."\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"lc\" value=\"".$my_lc."\" />";
		$return .="\n\t<input type=\"hidden\" name=\"cancel_return\" value=\"http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']."\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"return\" value=\" http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']."\" />";
		
		$return .= "\n\t<input type=\"hidden\" name=\"rm\" value=\"2\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"custom\" value=\"finish_the_order\" />";
		$return .= "\n\t<input type=\"hidden\" name=\"handling_cart\" value=\"".$cart_handling."\" />";
		
		$i = 0;
		foreach($cart_items as $item) {
			$i ++;
			$quantity = $item['amount'];
			$name = $item['product'] -> names[$this -> language];
			
			if($_SESSION['customer']->vat_area == "off"	&& $this->settings['dont_deal_with_taxes'] !== 'true'){
				$price = $item['product']->get_netto($this->settings['vat_full'], $this->settings['vat_reduced']);
			}else {$price = $item['product'] -> price;}
			$vat_rate = $this->settings['vat_'.$item['product']-> vat];
			$sum = $price;
			$return .= "\n\t<input type=\"hidden\" name=\"item_name_$i\" value = \"". $item['product'] -> names[$this -> language]."\" />";
			$return .= "\n\t<input type=\"hidden\" name=\"quantity_$i\" value=\"$quantity\" />";
			$return .= "\n\t<input type=\"hidden\" name=\"amount_$i\" value=\"$sum\" />";
			$return .= "\n\t<input type=\"hidden\" name=\"item_number_$i\" value = \"".$item['product'] -> counter."\" />";
		}

		$return .= "\n\t<input type=\"submit\" value=\"".$this -> buttons['go_to_paypal']. "\" class=\"shopButton\" />";
		$return .= "\n</form>";

		return $return;

	}
	
	function add_price_infos($product) {
		$return = "<br /><span class=\"price_info\">";
		if($this->settings['dont_deal_with_taxes'] == 'true') {
			$return .= $this->hints['price_info_no_vat'];
		}else
			{if(trim($this->hints['price_info_vat']) !== ''){
				if($product->vat == 'full') {
					$vat_rate = $this->settings['vat_full'];
				}
				if($product->vat == 'reduced') {
					$vat_rate = $this->settings['vat_reduced'];
				}
				if((int)$vat_rate == $vat_rate){
					$vat_rate = (int)$vat_rate;
				} else {$vat_rate = $this->writer->format_the_money($vat_rate);
				}
					$return .= trim($this->hints['price_info_vat'])." (" .$vat_rate. "%)";
			}
			}
		
		if(trim($this->hints['price_info_shipping']) !== ''){
				$return .="<br />". trim($this->hints['price_info_shipping']);
		}	
		$return .= "</span>";
		return $return;
	}
	
}
?>
